#version 430 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 texCoords;
layout(location = 3) in vec3 tangent;
layout(location = 4) in vec3 bitangent;

uniform mat4 model;
uniform mat4 projView;

out mat3 TBN;
out vec3 worldPos;
out vec3 transNormal;
out vec2 uv;

void main()
{
  gl_Position = projView * model * vec4(position, 1.0f);
  worldPos    = vec3(model * vec4(position, 1.0f));
  transNormal = normalize(mat3(transpose(inverse(model))) * normal);
  uv          = texCoords;

  vec3 T = normalize(vec3(model * vec4(tangent,   0.0)));
  vec3 B = normalize(vec3(model * vec4(bitangent, 0.0)));
  // vec3 N = normalize(vec3(model * vec4(normal,    0.0)));
  vec3 N = transNormal;
  TBN = mat3(T, B, N);
}
