#version 430 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 texCoords;

uniform mat4 model;
uniform mat4 projView;

out vec3 worldPos;
out vec3 transNormal;
out vec2 uv;

void main()
{
  gl_Position = projView * model * vec4(position, 1.0f);
  worldPos    = vec3(model * vec4(position, 1.0f));
  transNormal = normalize(mat3(transpose(inverse(model))) * normal);
  uv          = texCoords;
}
